/***********************************
* Copyright 1998 by Kevin MacDonald
* kmacdo01@student.vill.edu
***********************************/

/***********************************
* This is the table data structure 
* which is an extension of the
* QdbtTabular data structure.
***********************************/

#include "tabu.h"
#include "tabu.moc"
#include <sys/wait.h>
#include "info.h"

tabu::tabu(QWidget *parent, const char *name)
	:QdbtTabular(parent, name)
{
  tim = new QTimer(this);
  connect(tim, SIGNAL(timeout()),SLOT(update()));
  tim->start(1000*60*30, FALSE);

  citytimer = new QTimer(this);
  current = 0;
  connect(citytimer, SIGNAL(timeout()), SLOT(changeCapt()));
 
  citytimer->start(1000*4, FALSE);
}

void tabu::mousePressEvent(QMouseEvent *mouse){
  if (mouse->button()==RightButton){
     pop = new QPopupMenu();
     QPoint point = mapToGlobal(pos());
     point.setX(point.x()+mouse->x());
     point.setY( point.y()+mouse->y());
     pop->insertItem("Update Now!", this, SLOT(update()));
     pop->insertSeparator();
     pop->insertItem("Get Info", this, SLOT(getinfo()));
     pop->insertItem("Add/Remove Cities", this, SLOT(addremCity()));
//     pop->insertItem("Change Update Time", this, SLOT(chuptime()));
     pop->insertSeparator();
     pop->insertItem("Quit", qApp, SLOT(quit()));   
     


     pop->popup(point);
     pop->show();
     }
}

void tabu::mouseReleaseEvent(QMouseEvent *mouse){
  if (mouse->button()==RightButton){
     pop->hide();
     delete pop;
     }
}

tabu::update(){

info *k, *n;
char *city[30];

int nr=0, a;

  ifstream infile(".xweathrc");
  infile.getline(city[0] = new char[4] , 5);
  int pid = getweath(city[0]);
  nr++;
while (!(infile.eof())){
  infile.getline(city[nr] = new char[4],5);
  if (city[0] != '\0'){
    pid = getweath(city[nr] );
   nr++;}
  }
nr--;
for(a = 0; a<(nr);a++){
  wait(0);
  }

while (numRows() != 0 )
  removeRow(0);
 

for (a = 0;a<(nr);a++){
  arr[a] = new info(city[a]);
  addRow(arr[a]->getCity(),arr[a]->getTemp(),arr[a]->getHum(), arr[a]->getPressure(), arr[a]->getWind(), arr[a]->getWeath());
  }

infile.close();

QString xwea(arr[0]->getCity());
xwea.append(":");
xwea.append(arr[0]->getTemp());
xwea.append("                       XWinWeather");
setCaption(xwea);
resizeTable();

}

tabu::getweath (char *air){
int x;
char *argv[3];
if (!(x = fork () ))
  {
  argv[0] = "sh";
  argv[1] = "weather" ;
  argv[2] = air;
  if (air!="")
    execvp("sh",  &argv[0]);
  }
return x;
}

tabu::setCell(int row, int colnum, char *text, int width)
{
  QPixmap base(width,20), cloud;
  QPainter full;
  QdbtTableCell a;
  cloud.load("cloud.xpm");
  full.begin(&base);
  full.setFont(QFont("Times", 12, QFont::Bold));
  full.drawPixmap(0,0, cloud);
  full.drawText(0,15, text);
  full.end();

  a.setPixmap(&base);
  changeCell(&a,row,colnum);
  
    
}


tabu::addRow(char *city, char *temp, char *hum, char *press, char *wind, char *weath)
{

  insertRow(-1,FALSE);
  int Row = numRows() - 1;

  setCell(Row,0,city,100);
  setCell(Row,1,temp,30);
  setCell(Row,2,hum,45);
  setCell(Row,3, press,40);
  setCell(Row,4,wind,85);
  setCell(Row,5,weath,100);
  
  setColumnWidth(0,100);
  setColumnWidth(1,30);
  setColumnWidth(2,45);
  setColumnWidth(3,40);
  setColumnWidth(4,85);
  setColumnWidth(5,100);
  int width = 100+30+45+40+85+100;
  setMaximumSize(width+5, (numRows())*20+30);
  resize(width+5, (numRows())*20+30);
  emit tableResized();

}

tabu::removeThis(){
/*  char line[5];
  removeRow(row);
  
  ifstream infile(".xweathrc");
  ofstream outfile(".xweath");
  infile.tie(&outfile);
  for (int i=0;i<row;i++)
      infile.getline(line,5);
  infile.ignore(4);
  while (!infile.eof())
      infile.getline(line, 5);
  close(infile);
  close(outfile);
*/
}

void tabu::mouseMoveEvent(QMouseEvent *e)
{
  row = findRow(e->y());
}

tabu::addremCity()
{
  citychange = new addrem;
  citychange->show();
  connect(citychange, SIGNAL(changed()), SLOT(update()));
}


tabu::resizeTable(){
  resize(100+30+45+40+80+100+5+20, numRows()*30+30);
}

tabu::changeCapt(){
  if (numRows()>0)
    emit captionChanged(arr[current]->getCity(),arr[current]->getTemp());
  current++;
  if (current>(numRows()-1))
    current=0;
  }

tabu::chuptime(){
  QFrame *uptime = new QFrame;
  uptime->setGeometry(320,240,300,100);
  uptime->show();
}

tabu::getinfo(){
  infowin = new QFrame;
  infowin->setCaption("XWinWeather Get Info");
  infowin->resize(320,340);
  infowin->setBackgroundPixmap(QPixmap("info.xpm"));
  infowin->show();
  }
